/**
 ** sparkCntrlTaskCodels.cc
 **
 ** Codels used by the control task sparkCntrlTask
 **
 ** Author: 
 ** Date: 
 **
 **/

#include <portLib.h>

#include "server/sparkHeader.h"
#include "sparkm3d.h"



/*------------------------------------------------------------------------
 * sparkInterfaceAgenParamsCtrl  -  control codel of CONTROL request SetInterfaceAgentParams
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
sparkInterfaceAgenParamsCtrl(SPARK_INTERFACE_AGENT_PARAMS *interfaceAgentParams, int *report)
{
  int i;
  
  if(gAgents == NULL) 
    return ERROR;

  for(i=0; i<gAgents->all_agents_no; i++) {
    if(strcasestr(gAgents->all_agents[i]->robotPt->name, interfaceAgentParams->agentName.name)){
      if(interfaceAgentParams->showFov) 
	gAgents->all_agents[i]->perspective->enable_vision_draw = TRUE;
      else 
	gAgents->all_agents[i]->perspective->enable_vision_draw = FALSE;	
      
      if(interfaceAgentParams->showPoiting) 
	gAgents->all_agents[i]->perspective->enable_pointing_draw = TRUE;
      else 
	gAgents->all_agents[i]->perspective->enable_pointing_draw = FALSE;

      if(interfaceAgentParams->showVisibleObjects) 
	gAgents->all_agents[i]->perspective->enable_visible_objects_draw = TRUE;
      else 
	gAgents->all_agents[i]->perspective->enable_visible_objects_draw = FALSE;
    }
  }
  
  return OK;
}


/*------------------------------------------------------------------------
 * sparkSetInterfaceMightParamsCtrl  -  control codel of CONTROL request SetInterfaceMightParams
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
sparkSetInterfaceMightParamsCtrl(SPARK_INTERFACE_MIGHTABILITY_PARAMS *interfaceMightParams, int *report)
{
  // TODO:Fix mightabilities to compile with the latest version of BioMove3D (3.7.8)
  // SHOW_MM_BASED_OBJECT_VISIBLE = interfaceMightParams->showVisibleObjects;
  // SHOW_MM_BASED_OBJECT_REACHABLE = interfaceMightParams->showReachableObjects;
  
  return OK;
}

