/*****************************************************************************
*
* Emrah Akin Sisbot
* Aug 10 
*
* File : sparkMocap.h
* Brief: This file contains structures and function defs for motion capture point processing
*
******************************************************************************/

#ifndef SPARKMOCAP_H
#define SPARKMOCAP_H


#define CAL_PITCH_HAT 1 // To calibrate pitch of hat
#define CAL_YAW_HAT 2   // To calibrate yaw of hat

typedef struct point_coords {
  double x;
  double y;
  double z;
  double theta;
} point_coords;

extern void mocap_translate_markers_pos(MOCAP_OBJECTS *mocapObjects, double x, double y);
extern int mocap_compute_neck_position_from_helmet(MOCAP_MARKERS_OBJECT *object, double *x, double *y, double *z, double *yaw, double *pitch);
extern int mocap_compute_palm_position_from_glove(MOCAP_MARKERS_OBJECT *body, double *x, double *y, double *z);
extern int mocap_compute_neck_position_from_glasses(MOCAP_MARKERS_OBJECT *body, double *x, double *y, double *z, double *yaw, double *pitch); 
#endif
